
Ruby - Bug #5433

Bug # 5076 (Closed): Mac OS X Lion Support 

PTY.spawn Kernel panic on macos lion

10/11/2011 05:58 AM - argami (Gamaliel Toro)

Status: Third Party's Issue   

Priority: Normal   

Assignee: mrkn (Kenta Murata)   

Target version:    

ruby -v: ruby-1.9.2 Backport:  

Description

If you execute a PTY.spawn with a non existing command give a kernel panic.

Example

require 'pty'

PTY.spawn('nonexistent-command')

History

#1 - 10/11/2011 06:17 AM - argami (Gamaliel Toro)

Just happen in 1.9.2 in 1.9.3-head its ok

#2 - 10/11/2011 06:48 AM - drbrain (Eric Hodel)

On Ruby 1.9.2-p290 compiled with GCC (not LLVM-GCC) OS X 10.7.1 panics when I run your command.

#3 - 10/11/2011 05:41 PM - mrkn (Kenta Murata)

- Assignee set to mrkn (Kenta Murata)

#4 - 10/11/2011 05:42 PM - sorah (Sorah Fukumori)

Any kernel panic logs?

#5 - 10/11/2011 05:43 PM - mrkn (Kenta Murata)

Gamaliel, please give us the precise information of "ruby -v".

Moreover, please tell us what compiler you use for compiling your ruby.

#6 - 10/11/2011 05:44 PM - mrkn (Kenta Murata)

- Status changed from Open to Feedback

#7 - 10/11/2011 07:47 PM - argami (Gamaliel Toro)

ok in this 2 i have the issue

ruby 1.9.2p312 (2011-08-11 revision 32926) [x86_64-darwin11.0.1]

ruby 1.9.2p180 (2011-02-18 revision 30909) [x86_64-darwin11.0.1]

Both installed with RVM compiler is gcc-4.2

here is the log:

Interval Since Last Panic Report:  11524 sec

Panics Since Last Report:          9

Anonymous UUID:                    5F78A6A5-B768-4FE6-B6B3-CE638B44C1F2

Tue Oct 11 12:49:18 2011

panic(cpu 2 caller 0xffffff8000328b22): "Negative open count?"@/SourceCache/xnu/xnu-1699.23.4/bsd/miscfs/specfs/spec_vnops.c:1368

Backtrace (CPU 2), Frame : Return Address

0xffffff80b03f3c10 : 0xffffff8000220702

0xffffff80b03f3c90 : 0xffffff8000328b22

0xffffff80b03f3cd0 : 0xffffff800032c8c5

0xffffff80b03f3d20 : 0xffffff8000318f24

0xffffff80b03f3d60 : 0xffffff80002fd1da
0xffffff80b03f3db0 : 0xffffff80002fcede

0xffffff80b03f3df0 : 0xffffff80002fe401

0xffffff80b03f3e20 : 0xffffff8000316a4f

0xffffff80b03f3e50 : 0xffffff8000540e29

0xffffff80b03f3ec0 : 0xffffff800023b9db

0xffffff80b03f3ef0 : 0xffffff800023beda

0xffffff80b03f3f20 : 0xffffff800023bf70

0xffffff80b03f3f50 : 0xffffff800021e0ce

0xffffff80b03f3f90 : 0xffffff80002c1caa

0xffffff80b03f3fb0 : 0xffffff80002d7a0c

BSD process name corresponding to current thread: ruby

Mac OS version:

11B2118

Kernel version:

Darwin Kernel Version 11.0.1: Thu Jul 28 02:01:39 PDT 2011; root:xnu-1699.23.4~1/RELEASE_X86_64

Kernel UUID: 87D5C6BC-A017-3A47-ACE0-215AB85ACC2A

System model name: MacBookAir4,1 (Mac-C08A6BB70A942AC2)

System uptime in nanoseconds: 7159081099713

last loaded kext at 5971573891126: com.apple.iokit.SCSITaskUserClient 3.0.0 (addr 0xffffff7f80851000, size 36864)

last unloaded kext at 6067203917013: com.apple.driver.AppleUSBCDC 4.1.15 (addr 0xffffff7f80802000, size 12288)

loaded kexts:

com.apple.filesystems.smbfs 1.7.0

com.apple.driver.AppleHWSensor 1.9.4d0

com.apple.filesystems.autofs 3.0

com.apple.driver.AppleMikeyHIDDriver 122

com.apple.driver.AppleUpstreamUserClient 3.5.9

com.apple.driver.AppleMCCSControl 1.0.24

com.apple.driver.AppleHDA 2.1.2f23

com.apple.driver.AppleMikeyDriver 2.1.2f23

com.apple.driver.AppleIntelHDGraphics 7.0.6

com.apple.driver.ApplePlatformEnabler 2.0.4d2

com.apple.driver.AGPM 100.12.41

com.apple.driver.AudioAUUC 1.59

com.apple.iokit.IOUserEthernet 1.0.0d1

com.apple.Dont_Steal_Mac_OS_X 7.0.0

com.apple.driver.AudioIPCDriver 1.2.0

com.apple.driver.ACPI_SMC_PlatformPlugin 4.7.5d4

com.apple.driver.AppleLPC 1.5.3

com.apple.driver.AppleBacklight 170.1.9

com.apple.driver.AppleIntelSNBGraphicsFB 7.0.6

com.apple.driver.AppleSMCLMU 2.0.1d2

com.apple.driver.AppleUSBTCButtons 225.2

com.apple.driver.AppleUSBTCKeyboard 225.2

com.apple.AppleFSCompression.AppleFSCompressionTypeDataless 1.0.0d1

com.apple.AppleFSCompression.AppleFSCompressionTypeZlib 1.0.0d1

com.apple.BootCache 32

com.apple.iokit.IOAHCIBlockStorage 2.0.0

com.apple.driver.AppleUSBHub 4.4.5

com.apple.driver.AirPort.Brcm4331 511.20.10

com.apple.driver.AppleEFINVRAM 1.5.0

com.apple.driver.AppleSmartBatteryManager 161.0.0

com.apple.driver.AppleAHCIPort 2.1.9

com.apple.driver.AppleUSBEHCI 4.4.5

com.apple.driver.AppleACPIButtons 1.4

com.apple.driver.AppleRTC 1.4

com.apple.driver.AppleHPET 1.6

com.apple.driver.AppleSMBIOS 1.7

com.apple.driver.AppleACPIEC 1.4

com.apple.driver.AppleAPIC 1.5

com.apple.driver.AppleIntelCPUPowerManagementClient 166.0.0

com.apple.nke.applicationfirewall 3.0.30

com.apple.security.quarantine 1

com.apple.driver.AppleIntelCPUPowerManagement 166.0.0

com.apple.iokit.IOSCSIBlockCommandsDevice 3.0.0

com.apple.iokit.IOUSBMassStorageClass 3.0.0

com.apple.kext.triggers 1.0

com.apple.iokit.IOSCSIArchitectureModelFamily 3.0.0

com.apple.driver.DspFuncLib 2.1.2f23

com.apple.driver.AppleAVBAudio 1.0.0d11

com.apple.driver.AppleSMBusController 1.0.10d0

com.apple.iokit.IOSurface 80.0
com.apple.iokit.IOBluetoothSerialManager 4.0f4

com.apple.iokit.IOSerialFamily 10.0.5

com.apple.iokit.IOAVBFamily 1.0.0d22

com.apple.iokit.IOEthernetAVBController 1.0.0d5

com.apple.iokit.IOAudioFamily 1.8.3fc11

com.apple.kext.OSvKernDSPLib 1.3

com.apple.driver.AppleHDAController 2.1.2f23

com.apple.iokit.IOHDAFamily 2.1.2f23

com.apple.driver.IOPlatformPluginFamily 4.7.5d4

com.apple.driver.AppleSMBusPCI 1.0.10d0

com.apple.driver.AppleBacklightExpert 1.0.3

com.apple.iokit.IONDRVSupport 2.3

com.apple.driver.AppleSMC 3.1.1d2

com.apple.iokit.IOGraphicsFamily 2.3

com.apple.driver.AppleThunderboltDPInAdapter 1.3.5

com.apple.driver.AppleThunderboltDPAdapterFamily 1.3.5

com.apple.driver.AppleThunderboltPCIDownAdapter 1.1.6

com.apple.driver.BroadcomUSBBluetoothHCIController 4.0f4

com.apple.driver.AppleUSBBluetoothHCIController 4.0f4

com.apple.iokit.IOBluetoothFamily 4.0f4

com.apple.driver.AppleUSBMultitouch 225.4

com.apple.iokit.IOUSBHIDDriver 4.4.5

com.apple.driver.AppleUSBMergeNub 4.4.5

com.apple.driver.AppleUSBComposite 3.9.0

com.apple.driver.XsanFilter 403

com.apple.driver.AppleThunderboltNHI 1.2.6

com.apple.iokit.IOThunderboltFamily 1.5.1

com.apple.iokit.IOUSBUserClient 4.4.5

com.apple.iokit.IO80211Family 410.1

com.apple.iokit.IONetworkingFamily 2.0

com.apple.iokit.IOAHCIFamily 2.0.6

com.apple.iokit.IOUSBFamily 4.4.5

com.apple.driver.AppleEFIRuntime 1.5.0

com.apple.iokit.IOHIDFamily 1.7.0

com.apple.iokit.IOSMBusFamily 1.1

com.apple.security.sandbox 165

com.apple.kext.AppleMatch 1.0.0d1

com.apple.security.TMSafetyNet 7

com.apple.driver.DiskImages 330

com.apple.iokit.IOStorageFamily 1.7

com.apple.driver.AppleKeyStore 28.18

com.apple.driver.AppleACPIPlatform 1.4

com.apple.iokit.IOPCIFamily 2.6.5

com.apple.iokit.IOACPIFamily 1.4

Model: MacBookAir4,1, BootROM MBA41.0077.B08, 2 processors, Intel Core i5, 1.6 GHz, 4 GB, SMC 1.74f1

Graphics: Intel HD Graphics 3000, Intel HD Graphics 3000, Built-In, 384 MB

Memory Module: BANK 0/DIMM0, 2 GB, DDR3, 1333 MHz, 0x80CE, 0x4D34373142353737334448302D4348392020

Memory Module: BANK 1/DIMM0, 2 GB, DDR3, 1333 MHz, 0x80CE, 0x4D34373142353737334448302D4348392020

AirPort: spairport_wireless_card_type_airport_extreme (0x14E4, 0xE9), Broadcom BCM43xx 1.0 (5.100.98.75.10)

Bluetooth: Version 4.0.0f4, 2 service, 18 devices, 1 incoming serial ports

Network Service: Wi-Fi, AirPort, en0

Serial ATA Device: APPLE SSD TS128C, 121,33 GB

USB Device: FaceTime Camera (Built-in), apple_vendor_id, 0x850a, 0xfa200000 / 3

USB Device: hub_device, 0x0424  (SMSC), 0x2513, 0xfa100000 / 2

USB Device: BRCM20702 Hub, 0x0a5c  (Broadcom Corp.), 0x4500, 0xfa110000 / 5

USB Device: Bluetooth USB Host Controller, apple_vendor_id, 0x821f, 0xfa113000 / 7

USB Device: Apple Internal Keyboard / Trackpad, apple_vendor_id, 0x024a, 0xfa120000 / 4

USB Device: hub_device, 0x0424  (SMSC), 0x2513, 0xfd100000 / 2

#8 - 10/12/2011 05:50 PM - nobu (Nobuyoshi Nakada)

- Status changed from Feedback to Third Party's Issue

Obviously, kernel bug.

#9 - 10/12/2011 08:51 PM - kosaki (Motohiro KOSAKI)

Obviously, kernel bug.

 Even if so, we need workaround. isn't it?
#10 - 10/12/2011 09:09 PM - shyouhei (Shyouhei Urabe)

Motohiro KOSAKI wrote:

Obviously, kernel bug.

 Even if so, we need workaround. isn't it?

 It is an Apple's fault.

The first thing to be done is to blame Apple, not to report here.

You are a customer of Apple, not us.

However if you are not a customer but an employee of Apple, and you insist us to give a workaround, we can.  If it is the case please give us a more

detailed background of how to achieve it.

#11 - 10/12/2011 10:20 PM - argami (Gamaliel Toro)

So i have a question if is kernel bug why give a kernel error in 1.9.2 and not 1.9.3 or 1.8.7.

#12 - 10/12/2011 10:41 PM - shyouhei (Shyouhei Urabe)

@argami_toro It seems there may be some circumstances for Lion kernel to panic.

It is not always. 1.9.3 happen to hit that.

When Apple disclose that exact condition, we are possible to workaround.

#13 - 02/21/2012 10:32 AM - naruse (Yui NARUSE)

- Parent task set to #5076
